mode(-1);
lines(0);
TOOLBOX_NAME  = "HART";
TOOLBOX_TITLE = "Hardware access in realtime Toolbox";
toolbox_dir = get_absolute_file_path("builder.sce");
try
 v = getversion("scilab");
catch
 error(gettext("Scilab 5.0 or more is required."));
end;
// ====================================================================
if ~with_module("development_tools") then
   error(msprintf(gettext('%s module not installed."),'development_tools'));
end
// ====================================================================

tbx_builder_macros(toolbox_dir);
tbx_builder_src(toolbox_dir);
tbx_build_loader(TOOLBOX_NAME, toolbox_dir);
loadXcosLibs();


function xpal = tbx_build_pal(toolbox_dir, name, interfaces)
 h5_instances = toolbox_dir + filesep() + "images/h5/" + interfaces + ".sod";
 pal_icons = toolbox_dir + filesep() + "images/gif/" + interfaces + ".gif";
 graph_icons = toolbox_dir + filesep() + "images/svg/" + interfaces + ".svg";

 xpal = xcosPal(name);

 for i = 1:size(interfaces,1)
 // register to the palette.
 xpal = xcosPalAddBlock(xpal, h5_instances(i), pal_icons(i), graph_icons(i));
 end
endfunction

blklib = lib(toolbox_dir + 'macros/palettes/hart_base');
if (getos() == "Windows") then
blocks = [
"hart_filtfilt"
"hart_par2ser"
"hart_ser2par"
"hart_soft_realtime"
];
end;
if (getos() == "Linux" | getos() == "Darwin") then
blocks = [
"hart_filtfilt"
"hart_par2ser"
"hart_ser2par"
"hart_socket"
"hart_socketin"
"hart_soft_realtime"
];
end;
xpal = tbx_build_pal(toolbox_dir, "hart_base", blocks);
xcosPalAdd(xpal, ['Hart']);

//tbx_builder_gateway(toolbox_dir);
tbx_builder_help(toolbox_dir);
tbx_build_cleaner(TOOLBOX_NAME, toolbox_dir);
clear toolbox_dir;
clear TOOLBOX_NAME;
