function [x,y,typ] = hart_par2ser(job,arg1,arg2)
//parallel to serial block
//
// Block Screenshot
//
// Description
//
//This block takes a vector as input and gives back the single entries of the vector. After the last entry is given out, a new vector is taken from the input. So this block converts parallel data to serial data.
//
// Dialog box
//
// Channels: Number of input and output channels
// No of Samples: Size of input vector
//
// Default Properties
//
// always active: yes
// direct-feedthrough: no
// zero-crossing: no
// mode: no
// regular inputs:  port 1 : size [1,1] / type 1
// regular outputs: port 1 : size [1,1] / type 1
// number/sizes of activation inputs: 1
// number/sizes of activation outputs: 0
// continuous-time state: no
// discrete-time state: yes
// object discrete-time state: no
// name of computational function: rt_par2ser
//  
//
// Interfacing Function
// hart_par2ser.sci
// Computational Function
// hart_par2ser.c
// Authors
// Holger Nahrstaedt
//

  x=[];y=[];typ=[];
  select job
  case 'plot' then
    exprs=arg1.graphics.exprs;
    ch=exprs(1);
    samples=exprs(2);
    standard_draw(arg1)
  case 'getinputs' then
    [x,y,typ]=standard_inputs(arg1)
  case 'getoutputs' then
    [x,y,typ]=standard_outputs(arg1)
  case 'getorigin' then
    [x,y]=standard_origin(arg1)
  case 'set' then
    x=arg1
    model=arg1.model;graphics=arg1.graphics;
    exprs=graphics.exprs;
    while %t do
      try
      getversion('scilab');
      [ok,ch,samples,exprs]=..
      scicos_getvalue('Set par2ser block parameters',..
         ['Channels:';
          'No of Samples:'],..
      list('vec',-1,'vec',-1),exprs)
     catch
     [ok,ch,samples,exprs]=..
      getvalue('Set par2ser block parameters',..
         ['Channels:';
          'No of Samples:'],..
      list('vec',-1,'vec',-1),exprs)
     end
     if ~ok then break,end
      in=[ones(ch,1)*samples]
      out=[ones(ch,1)]
      evtin=[1]
      evtout=[]
      [model,graphics,ok]=check_io(model,graphics,in,out,evtin,evtout);
      if ok then
        graphics.exprs=exprs;
        model.ipar=[ch;
samples;
];
        model.rpar=[];
	  model.dstate=[];
        x.graphics=graphics;x.model=model
        break
      end
    end
  case 'define' then
     ch=1;
     samples=50;
   model=scicos_model()
   model.sim=list('rt_par2ser',4)
   model.in=[ones(ch,1)*samples]
   model.out=[ones(ch,1)]
   model.evtin=[1]
   model.evtout=[]
   model.ipar=[ch;
samples;
];
   model.rpar=[];
	model.dstate=[];
	model.blocktype='d';
	model.dep_ut=[%f %f];
    exprs=[sci2exp(ch);sci2exp(samples)]
    gr_i=['txt=[string(samples)+'' -> 1'';''par2ser'' ];';'xstringb(orig(1),orig(2),txt,sz(1),sz(2),''fill'');'];
    x=standard_define([3 2],model,exprs,gr_i)
case 'readout' then
      BLOCK.version=020;
      BLOCK.name='hart_par2ser';
      BLOCK.comp_name='rt_par2ser';
      BLOCK.desr_short='Set par2ser block parameters';
      BLOCK.dep_u=%f;
      BLOCK.dep_t=%f;
      BLOCK.blocktype='d';
      BLOCK.dstate='';
      BLOCK.IOmatrix=%f;
      BLOCK.in='ones(ch,1)*samples';
      BLOCK.out='ones(ch,1)';
      BLOCK.evtin='1';
      BLOCK.evtout='';
      BLOCK.size='3 2';
      BLOCK.completelabel=%f;
      BLOCK.label=[115,116,114,105,110,103,40,115,97,109,112,108,101,115,41,43,39,39,32,45,62,32,49,39,39,..
         59,39,39,112,97,114,50,115,101,114,39,39,10];
      BLOCK.ipar=[99,104,59,10,115,97,109,112,108,101,115,59,10];
      BLOCK.rpar=[];
      BLOCK.opar=[];
      BLOCK.parameter=list();
      BLOCK.parameter($+1)=[];
      BLOCK.parameter(1).name='ch';
      BLOCK.parameter(1).text='Channels:';
      BLOCK.parameter(1).type='vec';
      BLOCK.parameter(1).size='-1';
      BLOCK.parameter(1).init='1';
      BLOCK.parameter(1).visible_plot=%t;
      BLOCK.parameter($+1)=[];
      BLOCK.parameter(2).name='samples';
      BLOCK.parameter(2).text='No of Samples:';
      BLOCK.parameter(2).type='vec';
      BLOCK.parameter(2).size='-1';
      BLOCK.parameter(2).init='50';
      BLOCK.parameter(2).visible_plot=%t;
      x=BLOCK;
  end
endfunction
