function [x,y,typ] = hart_ser2par(job,arg1,arg2)
//serial to parallel block
//
// Block Screenshot
//
// Description
//
//This block takes singles values as input and save them in a vector. When the last entry of the vector is writen, the vector is avaible on the output.  So this block converts serial data to parallel data.
//
// Dialog box
//
// Channels: Number of input and output channels
// No of Samples: Size of output vector
//
// Default Properties
//
// always active: yes
// direct-feedthrough: no
// zero-crossing: no
// mode: no
// regular inputs:  port 1 : size [1,1] / type 1
// regular outputs: port 1 : size [1,1] / type 1
// number/sizes of activation inputs: 1
// number/sizes of activation outputs: 0
// continuous-time state: no
// discrete-time state: yes
// object discrete-time state: no
// name of computational function: rt_ser2par
//  
//
// Interfacing Function
// {hart_toolbox}/modules/hart_base/macros/hart_ser2par.sci
// Computational Function
// {hart_toolbox}/modules/hart_base/src/c/hart_ser2par.c
// Authors
// Holger Nahrstaedt
//

  x=[];y=[];typ=[];
  select job
  case 'plot' then
    exprs=arg1.graphics.exprs;
    ch=exprs(1);
    samples=exprs(2);
    standard_draw(arg1)
  case 'getinputs' then
    [x,y,typ]=standard_inputs(arg1)
  case 'getoutputs' then
    [x,y,typ]=standard_outputs(arg1)
  case 'getorigin' then
    [x,y]=standard_origin(arg1)
  case 'set' then
    x=arg1
    model=arg1.model;graphics=arg1.graphics;
    exprs=graphics.exprs;
    while %t do
      try
      getversion('scilab');
      [ok,ch,samples,exprs]=..
      scicos_getvalue('serial to parallel  block',..
         ['Channels:';
          'No of Samples:'],..
      list('vec',-1,'vec',-1),exprs)
     catch
            [ok,ch,samples,exprs]=..
       getvalue('serial to parallel  block',..
         ['Channels:';
          'No of Samples:'],..
      list('vec',-1,'vec',-1),exprs)
      end
     if ~ok then break,end
      in=[ones(ch,1)]
      out=[ones(ch,1)*samples]
      evtin=[1]
      evtout=[]
      [model,graphics,ok]=check_io(model,graphics,in,out,evtin,evtout)
      if ok then
        graphics.exprs=exprs;
        model.ipar=[ch;
samples
];
        model.rpar=[];
   model.dstate=[];
        x.graphics=graphics;x.model=model
        break
      end
    end
  case 'define' then
     ch=1;
     samples=50;
   model=scicos_model()
   model.sim=list('rt_ser2par',4)
   model.in=[ones(ch,1)]
   model.out=[ones(ch,1)*samples]
   model.evtin=[1]
   model.evtout=[]
   model.ipar=[ch;
samples
];
   model.rpar=[];
 model.dstate=[];
 model.blocktype='d';
 model.dep_ut=[%f %f];
    exprs=[sci2exp(ch);sci2exp(samples)]
    gr_i=['xstringb(orig(1),orig(2),[''1 -> ''+string(samples);''ser2par'' ],sz(1),sz(2),''fill'');'];
    x=standard_define([3 2],model,exprs,gr_i)
case 'readout' then
      BLOCK.version=010;
      BLOCK.name='hart_ser2par';
      BLOCK.comp_name='rt_ser2par';
      BLOCK.desr_short='serial to parallel  block';
      BLOCK.dep_u=%f;
      BLOCK.dep_t=%f;
      BLOCK.blocktype='d';
      BLOCK.dstate='';
      BLOCK.in='ones(ch,1)';
      BLOCK.out='ones(ch,1)*samples';
      BLOCK.evtin='1';
      BLOCK.evtout='';
      BLOCK.size='3 2';
      BLOCK.completelabel=%f;
      BLOCK.label=[39,39,49,32,45,62,32,39,39,43,115,116,114,105,110,103,40,115,97,109,112,108,101,115,41,..
         59,39,39,115,101,114,50,112,97,114,39,39,10];
      BLOCK.ipar=[99,104,59,10,115,97,109,112,108,101,115,10];
      BLOCK.rpar=[];
      BLOCK.parameter=list();
      BLOCK.parameter($+1)=[];
      BLOCK.parameter(1).name='ch';
      BLOCK.parameter(1).text='Channels:';
      BLOCK.parameter(1).type='vec';
      BLOCK.parameter(1).size='-1';
      BLOCK.parameter(1).init='1';
      BLOCK.parameter(1).visible_plot=%t;
      BLOCK.parameter($+1)=[];
      BLOCK.parameter(2).name='samples';
      BLOCK.parameter(2).text='No of Samples:';
      BLOCK.parameter(2).type='vec';
      BLOCK.parameter(2).size='-1';
      BLOCK.parameter(2).init='50';
      BLOCK.parameter(2).visible_plot=%t;
      x=BLOCK;
  end
endfunction
