function [x,y,typ] = hart_soft_realtime(job,arg1,arg2)
//soft realtime block
//
// Block Screenshot
//
// Description
//
//Put this block somewhere in your scicos diagram to make the execution     somewhat follow real time. Requires the sample time as the parameter. Set    this to the same value as sample time in Simulation parameters. This works    much better then the realtime scaling.  Set realtime scaling to zero!
//You can choose different type of waiting. RTC is the best choice, but need root rights. SELECT and NANOSLEEP can started as normal user. If No waiting is choosen,  this block can be used for measuring the excecution time.
//You should start scilab with root rights, if you want to use RTC properly. If you do the following you can use RTC as normal user:
//sudo chown -vv root:audio /dev/rtc
//sudo chmod g+rw /dev/rtc sudo bash echo 8192 &gt;    /proc/sys/dev/rtc/max-user-freq
//
// Dialog box
//
// RT scheduler:           0 - no RT scheduling. This means the priority and the scheduler          will not be changed.
//1 - use RT scheduling. Changes the priority and          the scheduler.
//Waiting:  0 RTC 1 SELECT 2 NANOSLEEP 3 HPET -1 No Waiting
//Compensate fo failure (only for RTC):    0 - no 1- yes
//sample time in ms:  Sample time.
//
// Default Properties
//
// always active: yes
// direct-feedthrough: no
// zero-crossing: no
// mode: no
// regular inputs:  port 1 : size [1,1] / type 1
// regular outputs: port 1 : size [1,1] / type 1
// number/sizes of activation inputs: 1
// number/sizes of activation outputs: 0
// continuous-time state: no
// discrete-time state: yes
// object discrete-time state: no
// name of computational function: rt_soft_realtime
//
//
// Interfacing Function
// {hart_toolbox}/modules/hart_base/macros/hart_soft_realtime.sci
// Computational Function
// {hart_toolbox}/modules/hart_base/src/c/hart_hart_soft_realtime.c
// Authors
// Holger Nahrstaedt
//

  x=[];y=[];typ=[];
  select job
  case 'plot' then
    exprs=arg1.graphics.exprs;
    standard_draw(arg1)
  case 'getinputs' then
    [x,y,typ]=standard_inputs(arg1)
  case 'getoutputs' then
    [x,y,typ]=standard_outputs(arg1)
  case 'getorigin' then
    [x,y]=standard_origin(arg1)
  case 'set' then
    x=arg1
    model=arg1.model;graphics=arg1.graphics;
    exprs=graphics.exprs;
    while %t do
    try
    getversion('scilab');
    if (getos()<>"Windows") then
       [ok,RT,waiting,failure,TA,exprs]=scicos_getvalue(..
	'Select properties:',..
	[' RT scheduler (0-> no RT sch., 1-> use RT sch.) ';..
	  'waiting (0-> RTC, 1-> SELECT, 2-> Nanosleep, 3-> HPET, -1-> No Waiting) ';..
           'Compensate for failure (0-> no, 1->yes) (only for RTC) ';..
           'sampletime in ms:'],..
	   list('vec',-1,'vec',-1,'vec',-1,'vec',-1),exprs);
	 else
	          [ok,RT,waiting,failure,TA,exprs]=scicos_getvalue(..
	'Select properties:',..
	[     ' RT scheduler (0-> no RT sch., 1-> use RT sch.) ';..
  'waiting (0-> QueryPerformanceCounter, -1-> No Waiting) ';..
	      'Compensate for failure (0-> no, 1->yes) ';..
           'sampletime in ms:'],..
	   list('vec',-1,'vec',-1,'vec',-1,'vec',-1),exprs);
	 end;
       catch
      if (getos()<>"Windows") then
       [ok,RT,waiting,failure,TA,exprs]=getvalue(..
	'Select properties:',..
	[' RT scheduler (0-> no RT sch., 1-> use RT sch.) ';..
	  'waiting (0-> RTC, 1-> SELECT, 2-> Nanosleep, 3-> HPET, -1-> No Waiting) ';..
           'Compensate for failure (0-> no, 1->yes) (only for RTC) ';..
           'sampletime in ms:'],..
	   list('vec',-1,'vec',-1,'vec',-1,'vec',-1),exprs);
	 else
	          [ok,RT,waiting,failure,TA,exprs]=getvalue(..
	'Select properties:',..
	[       ' RT scheduler (0-> no RT sch., 1-> use RT sch.) ';..
  'waiting (0-> QueryPerformanceCounter, -1-> No Waiting) ';..
	      'Compensate for failure (0-> no, 1->yes) ';..
           'sampletime in ms:'],..
	   list('vec',-1,'vec',-1,'vec',-1,'vec',-1),exprs);
	 end;
     end;
      if ~ok then break,end
    //  if (getos()<>"Windows") then
      outport=3;
    //else
    //  outport=2;
    //  end;
      if exists('outport') then out=ones(outport,1), in=[], else out=1, in=[], end
      [model,graphics,ok]=check_io(model,graphics,in,out,1,[])
      if ok then
        graphics.exprs=exprs;
        //if (getos()<>"Windows") then
        model.ipar=[RT;
                      waiting;
                      failure;
                      TA];
      //else
      //   model.ipar=[ waiting;
      //                failure;
    //                  TA];
      //  end
        model.rpar=[];
        model.dstate=[0];
        x.graphics=graphics;x.model=model
        break
      end
    end
  case 'define' then
    //if (getos()<>"Windows") then
      RT=1;
      waiting=0;
  //  else
  //    waiting=1;
  //  end
    failure=0;
    TA=100;
    model=scicos_model()
    model.sim=list('sci_soft_rt',4)
    //if (getos()<>"Windows") then
    outport=3;
    //else
    //outport=2;
    //end
    if exists('outport') then model.out=ones(outport,1), model.in=[], else model.out=1, model.in=[], end
    model.evtin=1
    model.rpar=[]
  //  if (getos()<>"Windows") then
      model.ipar=[RT;
               waiting;
               failure;
               TA];
  //  else
  //    model.ipar=[waiting;
  //             failure;
  //             TA];
  //  end
    model.dstate=[];
    model.blocktype='d'
    model.dep_ut=[%t %f]
 //if (getos()<>"Windows") then
    exprs=[sci2exp(RT);sci2exp(waiting);sci2exp(failure);sci2exp(TA)]
//else
//    exprs=[sci2exp(waiting);sci2exp(failure);sci2exp(TA)]
//  end
  //  if (getos()<>"Windows") then
    gr_i=['xstringb(orig(1),orig(2),[''RT_SYNC''],sz(1)*0.5,sz(2),''fill'');',
	'xstringb(orig(1)+sz(1)*0.8,orig(2),[''time'';''TA'';''Puffer''],sz(1)/10,sz(2),''fill'');']
//else
//      gr_i=['xstringb(orig(1),orig(2),[''RT_SYNC''],sz(1)*0.5,sz(2),''fill'');',
//	'xstringb(orig(1)+sz(1)*0.8,orig(2),[''time'';''TA'';],sz(1)/10,sz(2),''fill'');']
//  end
    x=standard_define([4 2],model,exprs,gr_i)
  end
endfunction
